/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.27
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.1 2004/11/24 16:36:38 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.27 2005/07/06 20:20:03 agriffis Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Description: This eclass is used as a central eclass for accessing kernel
6# source version, selected kernel options etc. 6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
7# 10#
11# Maintainer: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux
13#
14# Please direct your bugs to the current eclass maintainer :)
8 15
9ECLASS=linux-info 16# A Couple of env vars are available to effect usage of this eclass
17# These are as follows:
18#
19# Env Var Option Description
20# KERNEL_DIR <string> The directory containing kernel the target kernel
21# sources.
22# CONFIG_CHECK <string> a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR"
24# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!).
26# ie: CONFIG_CHECK="!MTRR"
27# ERROR_CFG <string> The error message to display when the above check
28# fails. <CFG> should reference the appropriate option
29# as above. ie: ERROR_MTRR="MTRR exists in the .config
30# but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from
32# the kernel makefile. This contains the directory
33# which is to be used as the kernel object directory.
34
35# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows:
37#
38# Env Var Option Description
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1
40# KV_MAJOR <integer> The kernel major version. ie: 2
41# KV_MINOR <integer> The kernel minor version. ie: 6
42# KV_PATCH <integer> The kernel patch version. ie: 9
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm
45# KV_DIR <string> The kernel source directory, will be null if
46# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless
48# koutput is used. This should be used for referencing
49# .config.
50
51# And to ensure all the weirdness with crosscompile
52inherit toolchain-funcs versionator
53
10INHERITED="$INHERITED $ECLASS" 54INHERITED="$INHERITED $ECLASS"
55EXPORT_FUNCTIONS pkg_setup
11 56
12# Overwritable environment Var's 57# Overwritable environment Var's
13# --------------------------------------- 58# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 59KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 60
16 61
62# Bug fixes
63# fix to bug #75034
64case ${ARCH} in
65 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
66 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
67esac
68
69# These are legacy wrappers for toolchain-funcs.
70# I dont like them here, but oh well.
71set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; }
72set_arch_to_portage() { export ARCH="$(tc-arch)"; }
73
74# qeinfo "Message"
75# -------------------
76# qeinfo is a quiet einfo call when EBUILD_PHASE
77# should not have visible output.
78qout() {
79 local outputmsg type
80 type=${1}
81 shift
82 outputmsg="${@}"
83 case "${EBUILD_PHASE}" in
84 depend) unset outputmsg;;
85 clean) unset outputmsg;;
86 preinst) unset outputmsg;;
87 esac
88 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
89}
90
91qeinfo() { qout einfo "${@}" ; }
92qeerror() { qout eerror "${@}" ; }
17 93
18# File Functions 94# File Functions
19# --------------------------------------- 95# ---------------------------------------
20 96
21# getfilevar accepts 2 vars as follows: 97# getfilevar accepts 2 vars as follows:
22# getfilevar <VARIABLE> <CONFIGFILE> 98# getfilevar <VARIABLE> <CONFIGFILE>
23 99
24getfilevar() { 100getfilevar() {
25local ERROR 101local ERROR workingdir basefname basedname myARCH="${ARCH}"
26 ERROR=0 102 ERROR=0
27 103
28 [ -z "${1}" ] && ERROR=1 104 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 105 [ ! -f "${2}" ] && ERROR=1
31 106
32 if [ "${ERROR}" = 1 ] 107 if [ "${ERROR}" = 1 ]
33 then 108 then
109 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 110 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 111 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 112 else
37 grep -e "^$1" $2 | sed 's: = :=:' | cut -d= -f2- 113 workingdir=${PWD}
38 fi 114 basefname=$(basename ${2})
39} 115 basedname=$(dirname ${2})
116 unset ARCH
40 117
41getfilevar_isset() { 118 cd ${basedname}
119 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
120 make ${BUILD_FIXES} -s -f - e 2>/dev/null
121 cd ${workingdir}
122
123 ARCH=${myARCH}
124 fi
125}
126
127linux_chkconfig_present() {
42local RESULT 128local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 129 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 130 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 131}
46 132
47getfilevar_ismodule() { 133linux_chkconfig_module() {
48local RESULT 134local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 135 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 136 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 137}
52 138
53getfilevar_isbuiltin() { 139linux_chkconfig_builtin() {
54local RESULT 140local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 141 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 142 [ "${RESULT}" = "y" ] && return 0 || return 1
143}
144
145linux_chkconfig_string() {
146 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config"
57} 147}
58 148
59# Versioning Functions 149# Versioning Functions
60# --------------------------------------- 150# ---------------------------------------
61 151
71# got the jist yet? 161# got the jist yet?
72 162
73kernel_is() { 163kernel_is() {
74 # if we haven't determined the version yet, we need too. 164 # if we haven't determined the version yet, we need too.
75 get_version; 165 get_version;
76 166 local operator test value x=0 y=0 z=0
77 local RESULT 167
78 RESULT=1 168 case ${1} in
79 169 lt) operator="-lt"; shift;;
80 if [ -n "${1}" ] 170 gt) operator="-gt"; shift;;
81 then 171 le) operator="-le"; shift;;
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0 172 ge) operator="-ge"; shift;;
83 fi 173 eq) operator="-eq"; shift;;
84 174 *) operator="-eq";;
85 if [ -n "${2}" ] 175 esac
86 then 176
87 RESULT=1 177 for x in ${@}; do
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0 178 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
89 fi 179 value="${value}${x}"
90 180 z=$((${z} + 1))
91 if [ -n "${3}" ] 181
92 then 182 case ${z} in
93 RESULT=1 183 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0 184 test="${test}${KV_MAJOR}";;
95 fi 185 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
96 return ${RESULT} 186 test="${test}${KV_MINOR}";;
187 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
188 test="${test}${KV_PATCH}";;
189 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
190 esac
191 done
192
193 [ ${test} ${operator} ${value} ] && return 0 || return 1
97} 194}
98 195
99get_version() { 196get_version() {
197 local kbuild_output
198
100 # no need to execute this twice assuming KV_FULL is populated. 199 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 200 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 201 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 202
109 # if we dont know KV_FULL, then we need too. 203 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 204 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 205 unset KV_DIR
112 206
113 # KV_DIR will contain the full path to the sources directory we should use 207 # KV_DIR will contain the full path to the sources directory we should use
114 einfo "Determining the location of the kernel source code" 208 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 209 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 210 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 211
118 if [ -z "${KV_DIR}" ] 212 if [ -z "${KV_DIR}" ]
119 then 213 then
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 214 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 215 qeinfo "This package requires Linux sources."
216 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
217 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
218 qeinfo "(or the kernel you wish to build against)."
219 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
220 else
221 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
122 fi 222 fi
223 return 1
224 fi
225
226 qeinfo "Found kernel source directory:"
227 qeinfo " ${KV_DIR}"
228
229 if [ ! -s "${KV_DIR}/Makefile" ]
230 then
231 qeerror "Could not find a Makefile in the kernel source directory."
232 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
233 return 1
234 fi
235
236 # OK so now we know our sources directory, but they might be using
237 # KBUILD_OUTPUT, and we need this for .config and localversions-*
238 # so we better find it eh?
239 # do we pass KBUILD_OUTPUT on the CLI?
240 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
241
242 # And if we didn't pass it, we can take a nosey in the Makefile
243 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
244 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
123 245
124 # And contrary to existing functions I feel we shouldn't trust the 246 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 247 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 248 # so we parse ${KV_DIR}/Makefile
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 249 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 250 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 251 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 252 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
253
254 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
255 then
256 qeerror "Could not detect kernel version."
257 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
258 return 1
259 fi
260
131 # and in newer versions we can also pull LOCALVERSION if it is set. 261 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 262 # but before we do this, we need to find if we use a different object directory.
133 263 # This *WILL* break if the user is using localversions, but we assume it was
264 # caught before this if they are.
265 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \
266 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}"
267
268 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
269 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
270 if [ -n "${KV_OUT_DIR}" ];
271 then
272 qeinfo "Found kernel object directory:"
273 qeinfo " ${KV_OUT_DIR}"
274
275 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)"
276 fi
277 # and if we STILL haven't got it, then we better just set it to KV_DIR
278 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
279
280 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)"
281 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
282 KV_LOCAL="${KV_LOCAL//\"/}"
283
134 # And we should set KV_FULL to the full expanded version 284 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 285 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 286
137 if [ -z "${KV_FULL}" ] 287 qeinfo "Found sources for kernel version:"
288 qeinfo " ${KV_FULL}"
289
290 if [ ! -s "${KV_OUT_DIR}/.config" ]
138 then 291 then
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 292 qeerror "Could not find a usable .config in the kernel source directory."
140 eerror "Please check a kernel source exists in this directory." 293 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
141 die 294 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
295 qeerror "it points to the necessary object directory so that it might find .config."
296 return 1
297 fi
298
299 return 0
300}
301
302get_running_version() {
303 KV_FULL=$(uname -r)
304
305 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
306 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
307 unset KV_FULL
308 get_version
309 return $?
310 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
311 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
312 unset KV_FULL
313 get_version
314 return $?
142 else 315 else
143 einfo "Found kernel source directory:" 316 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 317 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 318 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 319 KV_PATCH=${KV_PATCH//-*}
320 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
321 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 322 fi
323 return 0
148} 324}
149
150
151 325
152 326
153# ebuild check functions 327# ebuild check functions
154# --------------------------------------- 328# ---------------------------------------
155 329
156check_kernel_built() { 330check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 331 # if we haven't determined the version yet, we need too.
158 get_version; 332 get_version;
159 333
160 if [ ! -f "${KV_DIR}/System.map" ] 334 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 335 then
162 eerror "These sources have not yet been compiled." 336 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 337 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 338 eerror "To resolve this, please type the following:"
165 eerror 339 eerror
166 eerror "# cd ${KV_DIR}" 340 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 341 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 342 eerror "# make modules_prepare"
169 eerror 343 eerror
170 eerror "Then please try merging this module again." 344 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 345 die "Kernel sources need compiling first"
172 fi 346 fi
173} 347}
174 348
175check_modules_supported() { 349check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 350 # if we haven't determined the version yet, we need too.
177 get_version; 351 get_version;
178 352
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 353 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 354 then
182 eerror "These sources do not support loading external modules." 355 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 356 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 357 eerror "in your kernel, recompile and then try merging this module again."
358 die "No support for external modules in ${KV_FULL} config"
359 fi
360}
361
362check_extra_config() {
363 local config negate error local_error i n temp_config
364
365 # if we haven't determined the version yet, we need too.
366 get_version;
367
368 einfo "Checking for suitable kernel configuration options"
369 for config in ${CONFIG_CHECK}
370 do
371 negate="${config:0:1}"
372 if [ "${negate}" == "!" ];
373 then
374 config="${config:1}"
375 if linux_chkconfig_present ${config}
376 then
377 local_error="${config}_ERROR"
378 local_error="${!local_error}"
379 [ -n "${local_error}" ] && eerror " ${local_error}" || \
380 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
381 error=1
382 fi
383 elif [ "${negate}" == "@" ];
384 then
385 # we never call this unless we are using MODULE_NAMES
386
387 config="${config:1}"
388 temp_config="${config//*:}"
389 config="${config//:*}"
390 if linux_chkconfig_present ${config}
391 then
392 local_error="${config}_ERROR"
393 local_error="${!local_error}"
394 [ -n "${local_error}" ] && eerror " ${local_error}" || \
395 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
396
397 for i in ${MODULE_NAMES}
398 do
399 n="${i//${temp_config}}"
400 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
401 done
402 error=0
403 fi
404 else
405 if ! linux_chkconfig_present ${config}
406 then
407 # Support the new syntax first.
408 local_error="ERROR_${config}"
409 local_error="${!local_error}"
410
411 # then fall back on the older syntax.
412 if [[ -z ${local_error} ]] ; then
413 local_error="${config}_ERROR"
414 local_error="${!local_error}"
415 fi
416
417 [[ -n ${local_error} ]] && eerror " ${local_error}" || \
418 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
419 error=1
420 fi
421 fi
422 done
423
424 if [ "${error}" == 1 ] ;
425 then
426 eerror "Please check to make sure these options are set correctly."
427 eerror "Once you have satisfied these options, please try merging"
428 eerror "this package again."
429 die "Incorrect kernel configuration options"
185 fi 430 fi
186} 431}
187 432
188check_zlibinflate() { 433check_zlibinflate() {
189 # if we haven't determined the version yet, we need too. 434 # if we haven't determined the version yet, we need too.
221 466
222 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 467 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
223 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 468 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
224 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 469 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
225 (( LINENO_END = $LINENO_END - 1 )) 470 (( LINENO_END = $LINENO_END - 1 ))
226 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 471 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
227 472
228 # okay, now we have a list of symbols 473 # okay, now we have a list of symbols
229 # we need to check each one in turn, to see whether it is set or not 474 # we need to check each one in turn, to see whether it is set or not
230 for x in $SYMBOLS ; do 475 for x in $SYMBOLS ; do
231 if [ "${!x}" = "y" ]; then 476 if [ "${!x}" = "y" ]; then
252 eerror "Please remember to recompile and install your kernel, and reboot" 497 eerror "Please remember to recompile and install your kernel, and reboot"
253 eerror "into your new kernel before attempting to load this kernel module." 498 eerror "into your new kernel before attempting to load this kernel module."
254 499
255 die "Kernel doesn't include zlib support" 500 die "Kernel doesn't include zlib support"
256} 501}
502
503################################
504# Default pkg_setup
505# Also used when inheriting linux-mod to force a get_version call
506
507linux-info_pkg_setup() {
508 get_version || die "Unable to calculate Linux Kernel version"
509 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
510}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.27

  ViewVC Help
Powered by ViewVC 1.1.20